## kbibtex 0.8.1

=== CMakeLists.txt ===
if(POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW)
endif(POLICY CMP0048)

project(
    kbibtex
    VERSION "0.8.1"
)

cmake_minimum_required(
    VERSION
    3.2.0
    FATAL_ERROR
)

set(
    QT_MIN_VERSION "5.6.0"
)
set(
    KF5_MIN_VERSION "5.26.0"
)

find_package(ECM 5.19 REQUIRED NO_MODULE)

add_definitions(
    -DTRANSLATION_DOMAIN="kbibtex"
    -DHAVE_QTWIDGETS
    -DHAVE_KF5
    -DHAVE_ICU
)

set(
    CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}/cmake/modules
    ${ECM_MODULE_PATH}
    ${ECM_KDE_MODULE_DIR}
    ${CMAKE_MODULE_PATH}
)


include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
include(GenerateExportHeader)

find_package(
    Qt5 ${QT_MIN_VERSION}
    CONFIG
    REQUIRED
    Core
    Widgets
    Network
    XmlPatterns
)

if(
    BUILD_TESTING
)
    find_package(
        Qt5Test ${QT_MIN_VERSION}
        CONFIG
        REQUIRED
    )

    if (WRITE_RAWDATAFILE)
        add_definitions(-DWRITE_RAWDATAFILE)
    endif(WRITE_RAWDATAFILE)

    set(
        TESTSET_DIRECTORY ""
        CACHE PATH
        "Directory where the local checkout of Git repository 'kbibtex-testset' is located"
    )
endif(
    BUILD_TESTING
)

find_package(
    Qt5WebEngineWidgets ${QT_MIN_VERSION}
    QUIET
    CONFIG
)

find_package(
    Qt5WebKitWidgets ${QT_MIN_VERSION}
    QUIET
    CONFIG
)

find_package(
    KF5 ${KF5_MIN_VERSION}
    REQUIRED
    I18n
    XmlGui
    KIO
    IconThemes
    ItemViews
    Completion
    Parts
    CoreAddons
    Service
    Wallet
    Crash
)

find_package(KF5DocTools)

ecm_setup_version(
    PROJECT
    VARIABLE_PREFIX KBIBTEX
    SOVERSION ${KBIBTEX_VERSION_MAJOR}
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kbibtex-version.h"
)

# Compute a 'patch level' even if none were given in the program version
if(KBIBTEX_VERSION_PATCH STREQUAL "")
    set(KBIBTEX_VERSION_PATCH_VALUE 0)
else(KBIBTEX_VERSION_PATCH STREQUAL "")
    set(KBIBTEX_VERSION_PATCH_VALUE KBIBTEX_VERSION_PATCH)
endif(KBIBTEX_VERSION_PATCH STREQUAL "")


if((${KBIBTEX_VERSION_PATCH_VALUE} GREATER 50) OR (${KBIBTEX_VERSION_PATCH_VALUE} EQUAL 50))
    # If the version number indicates a pre-release version such as
    # '0.7.90', i.e. a beta version for the major release 0.8, so
    # increment release version from 0.7 to 0.8
    math(EXPR KBIBTEX_RELEASE_VERSION_MINOR "${KBIBTEX_VERSION_MINOR} + 1")
    set(
        KBIBTEX_RELEASE_VERSION ${KBIBTEX_VERSION_MAJOR}.${KBIBTEX_RELEASE_VERSION_MINOR}
    )
else((${KBIBTEX_VERSION_PATCH_VALUE} GREATER 50) OR (${KBIBTEX_VERSION_PATCH_VALUE} EQUAL 50))
    # Patch level is less than 50, i.e. it is a regular bugfix release
    # on a stable release
    set(
        KBIBTEX_RELEASE_VERSION ${KBIBTEX_VERSION_MAJOR}.${KBIBTEX_VERSION_MINOR}
    )
endif((${KBIBTEX_VERSION_PATCH_VALUE} GREATER 50) OR (${KBIBTEX_VERSION_PATCH_VALUE} EQUAL 50))

option(
    UNITY_BUILD
    "Compile multiple C++ files in one big, merged file (\"Unity build\")\nSee also http://t-fischer.dreamwidth.org/3054.html"
)
if(UNITY_BUILD)
    message(STATUS "Unity build enabled")
else(UNITY_BUILD)
    message(STATUS "Unity build disabled (default), use option UNITY_BUILD to enable it")
endif(UNITY_BUILD)

# # FIXME may have to be cleaned up a little bit
# # Contributed by Jeremy Cribb <cribb.jeremy@gmail.com>
# if(
#     APPLE
# )
#     find_library(
#         SYS_CONFIG_LIBRARY
#         SystemConfiguration
#     )
#     mark_as_advanced(
#         SYS_CONFIG_LIBRARY
#     )
#     # SET(TARGET_EXTERNAL_LIBRARIES iconv ${SYS_CONFIG_LIBRARY})
#     set(
#         ICONV_INCLUDE_DIR
#         "/opt/local/include"
#     )
#     set(
#         ICONV_LIBRARIES
#         "/opt/local/lib/libiconv.dylib"
#     )
#     set(
#         LIBXSLT_LIBRARIES
#         "/opt/local/lib/libxslt.dylib"
#     )
# endif(
#     APPLE
# )

find_package(
    Poppler
    REQUIRED
    COMPONENTS
    Qt5
)

find_package(
    ICU
    REQUIRED
    COMPONENTS uc i18n
)
if(
    ICU_FOUND
)
    message(
        STATUS
        "Found ICU " ${ICU_VERSION}
    )
    include_directories(${ICU_INCLUDE_DIRS})
endif(
    ICU_FOUND
)

find_package(
    Qca-qt5 "2.1.0"
)
find_package(
    QtOAuth
)
if (Qca-qt5_FOUND AND QTOAUTH_FOUND)
    message(STATUS "Found Qca-qt5 " ${Qca-qt5_VERSION} " and QtOAuth")
    add_definitions(-DHAVE_ZOTERO=1)
    set(BUILD_ZOTERO ON)
else(Qca-qt5_FOUND AND QTOAUTH_FOUND)
    message(STATUS "No Qca-qt5 or no QtOAuth, disabling certain functionality")
    set(BUILD_ZOTERO OFF)
endif(Qca-qt5_FOUND AND QTOAUTH_FOUND)

# Make an educated guess where to find headers for QCA-Qt5
# TODO isn't there an "official" way to determine this directory?
find_path(
    QTCRYPTO_INCLUDE_DIR qca.h
    HINTS ENV ${Qt5Core_INCLUDE_DIRS} ENV ${QT_INCLUDES}
    PATH_SUFFIXES QtCrypto
)


add_subdirectory(
    config
)
add_subdirectory(
    src
)
add_subdirectory(
    xslt
)
add_subdirectory(
    mime
)
if(KF5DocTools_FOUND)
    add_subdirectory(doc)
endif()
# macro_optional_add_subdirectory(
#     po
# )

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== doc/CMakeLists.txt ===
# Create and install documentation (handbook)

kdoctools_create_handbook(
    index.docbook
    INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en
    SUBDIR kbibtex
)

# Create and install documentation (man page)

kdoctools_create_manpage(
    man-kbibtex.1.docbook 1
    INSTALL_DESTINATION ${MAN_INSTALL_DIR}
)

=== xslt/CMakeLists.txt ===
install(
    FILES
    fancy.xsl
    standard.xsl
    abstractonly.xsl
    arxiv2bibtex.xsl
    pubmed2bibtex.xsl
    pam2bibtex.xsl
    isbndb2bibtex.xsl
    ieeexplore2bibtex.xsl
    wikipedia-cite.xsl
    worldcatdc2bibtex.xsl
    DESTINATION
    ${KDE_INSTALL_DATADIR}/kbibtex
)

=== src/config/CMakeLists.txt ===
# KBibTeXConfig library

set(
    kbibtexconfig_LIB_SRCS
    notificationhub.cpp
    bibtexentries.cpp
    bibtexfields.cpp
    logging_config.cpp
)

set(
    kbibtexconfig_HDRS
    notificationhub.h
    bibtexentries.h
    bibtexfields.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexconfig kbibtexconfig_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_SOURCE_DIR}/src/global
)

add_library(
    kbibtexconfig
    SHARED
    ${kbibtexconfig_LIB_SRCS}
)

target_link_libraries( kbibtexconfig
    Qt5::Core
    KF5::I18n
    KF5::XmlGui
)

set_target_properties(
    kbibtexconfig
    PROPERTIES
    EXPORT_NAME "kbibtexconfig"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexconfig
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexconfig )

=== src/data/CMakeLists.txt ===
# KBibTeXData library

set(
    kbibtexdata_LIB_SRCS
    comment.cpp
    element.cpp
    entry.cpp
    file.cpp
    macro.cpp
    preamble.cpp
    value.cpp
    models/filemodel.cpp
    ${CMAKE_SOURCE_DIR}/src/global/kbibtex.cpp
    ${CMAKE_SOURCE_DIR}/src/global/preferences.cpp
    logging_data.cpp
)

set(
    kbibtexdata_HDRS
    comment.h
    element.h
    entry.h
    file.h
    macro.h
    preamble.h
    value.h
    models/filemodel.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexdata kbibtexdata_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/global
)

add_library(
    kbibtexdata
    SHARED
    ${kbibtexdata_LIB_SRCS}
)

target_link_libraries( kbibtexdata
    Qt5::Core
    Qt5::Widgets
    KF5::I18n
    KF5::XmlGui
    kbibtexconfig
)

set_target_properties(
    kbibtexdata
    PROPERTIES
    EXPORT_NAME "kbibtexdata"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexdata
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexdata )

=== src/gui/CMakeLists.txt ===
# KBibTeX GUI library

set(
    kbibtexgui_LIB_SRCS
    field/fieldinput.cpp
    field/fieldlineedit.cpp
    field/fieldlistedit.cpp
    field/colorlabelwidget.cpp
    file/fileview.cpp
    file/filedelegate.cpp
    file/partwidget.cpp
    file/findduplicatesui.cpp
    file/clipboard.cpp
    file/basicfileview.cpp
    file/sortfilterfilemodel.cpp
    element/elementeditor.cpp
    element/elementwidgets.cpp
    element/findpdfui.cpp
    element/associatedfilesui.cpp
    widgets/menulineedit.cpp
    widgets/filesettingswidget.cpp
    widgets/filterbar.cpp
    widgets/radiobuttontreeview.cpp
    widgets/hidingtabwidget.cpp
    widgets/starrating.cpp
    widgets/rangewidget.cpp
    config/entrylayout.cpp
    preferences/kbibtexpreferencesdialog.cpp
    preferences/settingsgeneralwidget.cpp
    preferences/settingsglobalkeywordswidget.cpp
    preferences/settingscolorlabelwidget.cpp
    preferences/settingsuserinterfacewidget.cpp
    preferences/settingsfileexporterpdfpswidget.cpp
    preferences/settingsfileexporterwidget.cpp
    preferences/settingsabstractwidget.cpp
    preferences/settingsidsuggestionswidget.cpp
    preferences/settingsidsuggestionseditor.cpp
    guihelper.cpp
    italictextitemmodel.cpp
    valuelistmodel.cpp
    delayedexecutiontimer.cpp
    ${CMAKE_SOURCE_DIR}/src/global/kbibtex.cpp
    ${CMAKE_SOURCE_DIR}/src/global/preferences.cpp
    logging_gui.cpp
)

set(
    kbibtexgui_HDRS
    field/fieldinput.h
    field/colorlabelwidget.h
    field/fieldlineedit.h
    widgets/filterbar.h
    preferences/settingsuserinterfacewidget.h
    preferences/kbibtexpreferencesdialog.h
    preferences/settingsglobalkeywordswidget.h
    preferences/settingsfileexporterwidget.h
    preferences/settingsgeneralwidget.h
    preferences/settingsabstractwidget.h
    preferences/settingscolorlabelwidget.h
    preferences/settingsfileexporterpdfpswidget.h
    preferences/settingsidsuggestionswidget.h
    preferences/settingsidsuggestionseditor.h
    guihelper.h
    valuelistmodel.h
    italictextitemmodel.h
    delayedexecutiontimer.h
    file/findduplicatesui.h
    file/basicfileview.h
    file/clipboard.h
    file/fileview.h
    file/filedelegate.h
    file/sortfilterfilemodel.h
    file/partwidget.h
    element/findpdfui.h
    element/elementeditor.h
    element/associatedfilesui.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexgui kbibtexgui_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_BINARY_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/io/config
    ${CMAKE_SOURCE_DIR}/src/networking
    ${CMAKE_BINARY_DIR}/src/networking
    ${CMAKE_SOURCE_DIR}/src/processing
    ${CMAKE_BINARY_DIR}/src/processing
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_BINARY_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/src/gui/file
    ${CMAKE_SOURCE_DIR}/src/gui/dialogs
    ${CMAKE_SOURCE_DIR}/src/gui/element
    ${CMAKE_SOURCE_DIR}/src/gui/field
    ${CMAKE_SOURCE_DIR}/src/gui/widgets
    ${CMAKE_SOURCE_DIR}/src/gui/config
    ${CMAKE_SOURCE_DIR}/src/global
)

add_library(
    kbibtexgui
    SHARED
    ${kbibtexgui_LIB_SRCS}
)

target_link_libraries( kbibtexgui
    Qt5::Core
    KF5::IconThemes
    KF5::ItemViews
    KF5::Completion
    kbibtexconfig
    kbibtexdata
    kbibtexio
    kbibtexnetworking
    kbibtexproc
)

set_target_properties(
    kbibtexgui
    PROPERTIES
    EXPORT_NAME "kbibtexgui"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexgui
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexgui )

=== src/io/CMakeLists.txt ===
# KBibTeXIO library

set(
    kbibtexio_LIB_SRCS
    encoder.cpp
    encoderlatex.cpp
    encoderxml.cpp
    fileexporterbibtex2html.cpp
    fileexporterbibtex.cpp
    fileexporterbibutils.cpp
    fileexporterbibtexoutput.cpp
    fileexporter.cpp
    fileexporterpdf.cpp
    fileexporterps.cpp
    fileexporterris.cpp
    fileexporterrtf.cpp
    fileexportertoolchain.cpp
    fileexporterxml.cpp
    fileexporterxslt.cpp
    fileimporterbibtex.cpp
    fileimporterbibutils.cpp
    fileimporter.cpp
    fileimporterpdf.cpp
    fileimporterris.cpp
    fileinfo.cpp
    textencoder.cpp
    bibutils.cpp
    xsltransform.cpp
    ${CMAKE_SOURCE_DIR}/src/global/kbibtex.cpp
    ${CMAKE_SOURCE_DIR}/src/global/preferences.cpp
    logging_io.cpp
)

set(
    kbibtexio_HDRS
    encoder.h
    encoderlatex.h
    encoderxml.h
    fileexporterbibtex2html.h
    fileexporterbibtex.h
    fileexporterbibutils.h
    fileexporterbibtexoutput.h
    fileexporter.h
    fileexporterpdf.h
    fileexporterps.h
    fileexporterris.h
    fileexporterrtf.h
    fileexportertoolchain.h
    fileexporterxml.h
    fileexporterxslt.h
    fileimporterbibtex.h
    fileimporterbibutils.h
    fileimporter.h
    fileimporterpdf.h
    fileimporterris.h
    fileinfo.h
    textencoder.h
    bibutils.h
    xsltransform.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexio kbibtexio_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/global
)

add_library(
    kbibtexio
    SHARED
    ${kbibtexio_LIB_SRCS}
)

target_link_libraries( kbibtexio
    Qt5::Core
    Qt5::Widgets
    Qt5::XmlPatterns
    KF5::I18n
    KF5::XmlGui
    Poppler::Qt5
    ${ICU_LIBRARIES}
    kbibtexconfig
    kbibtexdata
)

set_target_properties(
    kbibtexio
    PROPERTIES
    EXPORT_NAME "kbibtexio"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexio
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexio )

=== src/networking/CMakeLists.txt ===
# Network library

set(
    kbibtexnetworking_LIB_SRCS
    onlinesearch/onlinesearchabstract.cpp
    onlinesearch/onlinesearchbibsonomy.cpp
    onlinesearch/onlinesearcharxiv.cpp
    onlinesearch/onlinesearchsciencedirect.cpp
    onlinesearch/onlinesearchgooglescholar.cpp
    onlinesearch/onlinesearchieeexplore.cpp
    onlinesearch/onlinesearchpubmed.cpp
    onlinesearch/onlinesearchacmportal.cpp
    onlinesearch/onlinesearchspringerlink.cpp
    onlinesearch/onlinesearchjstor.cpp
    onlinesearch/onlinesearchmathscinet.cpp
    onlinesearch/onlinesearchmrlookup.cpp
    onlinesearch/onlinesearchinspirehep.cpp
    onlinesearch/onlinesearchcernds.cpp
    onlinesearch/onlinesearchingentaconnect.cpp
    onlinesearch/onlinesearchsimplebibtexdownload.cpp
    onlinesearch/onlinesearchgeneral.cpp
    onlinesearch/onlinesearchsoanasaads.cpp
    # onlinesearch/onlinesearchisbndb.cpp # disabled as provider switched to a paid model on 2017-12-26
    onlinesearch/onlinesearchideasrepec.cpp
    onlinesearch/onlinesearchdoi.cpp
    onlinesearch/onlinesearchbiorxiv.cpp
    associatedfiles.cpp
    findpdf.cpp
    internalnetworkaccessmanager.cpp
    ${CMAKE_SOURCE_DIR}/src/global/kbibtex.cpp
    logging_networking.cpp
)

if(BUILD_ZOTERO)
    list(
        APPEND
        kbibtexnetworking_LIB_SRCS
        zotero/api.cpp
        zotero/collectionmodel.cpp
        zotero/collection.cpp
        zotero/items.cpp
        zotero/groups.cpp
        zotero/oauthwizard.cpp
        zotero/tags.cpp
        zotero/tagmodel.cpp
        )
endif(BUILD_ZOTERO)

set(
    kbibtexnetworking_HDRS
    onlinesearch/onlinesearchgeneral.h
    onlinesearch/onlinesearchsciencedirect.h
    onlinesearch/onlinesearchabstract.h
    onlinesearch/onlinesearchacmportal.h
    onlinesearch/onlinesearchbibsonomy.h
    onlinesearch/onlinesearchgooglescholar.h
    onlinesearch/onlinesearchspringerlink.h
    onlinesearch/onlinesearchjstor.h
    onlinesearch/onlinesearchieeexplore.h
    onlinesearch/onlinesearcharxiv.h
    onlinesearch/onlinesearchpubmed.h
    onlinesearch/onlinesearchingentaconnect.h
    onlinesearch/onlinesearchsimplebibtexdownload.h
    onlinesearch/onlinesearchsoanasaads.h
    onlinesearch/onlinesearchmathscinet.h
    onlinesearch/onlinesearchmrlookup.h
    onlinesearch/onlinesearchinspirehep.h
    onlinesearch/onlinesearchcernds.h
    onlinesearch/onlinesearchisbndb.h
    onlinesearch/onlinesearchideasrepec.h
    onlinesearch/onlinesearchdoi.h
    onlinesearch/onlinesearchbiorxiv.h
    zotero/collectionmodel.h
    zotero/collection.h
    zotero/groups.h
    zotero/tags.h
    zotero/tagmodel.h
    zotero/items.h
    zotero/api.h
    zotero/oauthwizard.h
    associatedfiles.h
    findpdf.h
    internalnetworkaccessmanager.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexnetworking kbibtexnetworking_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/networking/onlinesearch
    ${CMAKE_SOURCE_DIR}/src/networking
    ${CMAKE_SOURCE_DIR}/src/global
)

add_library(
    kbibtexnetworking
    SHARED
    ${kbibtexnetworking_LIB_SRCS}
)

target_link_libraries(
    kbibtexnetworking
    Qt5::Core
    Qt5::Widgets
    Qt5::Network
    KF5::I18n
    KF5::XmlGui
    KF5::Completion
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::KIONTLM
    KF5::Wallet
    kbibtexconfig
    kbibtexdata
    kbibtexio
    Poppler::Qt5
)

if(BUILD_ZOTERO)
    include_directories(
        ${QTOAUTH_INCLUDE_DIR}
    )
    target_link_libraries(
        kbibtexnetworking
        qca-qt5
        ${QTOAUTH_LIBRARY}
    )
endif(BUILD_ZOTERO)


set_target_properties(
    kbibtexnetworking
    PROPERTIES
    EXPORT_NAME "kbibtexnetworking"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexnetworking
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexnetworking )

=== src/parts/CMakeLists.txt ===
# KBibTeX KPart

set(
    kbibtexpart_SRCS
    part.cpp
    partfactory.cpp
    browserextension.cpp
    ${CMAKE_SOURCE_DIR}/src/global/preferences.cpp
    logging_parts.cpp
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexpart kbibtexpart_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/src/gui/config
    ${CMAKE_SOURCE_DIR}/src/gui/element
    ${CMAKE_SOURCE_DIR}/src/gui/preferences
    ${CMAKE_SOURCE_DIR}/src/gui/widgets
    ${CMAKE_SOURCE_DIR}/src/gui/file
    ${CMAKE_SOURCE_DIR}/src/processing
    ${CMAKE_SOURCE_DIR}/src/networking
    ${CMAKE_SOURCE_DIR}/src/global
)

# Creates kbibtex-git-info.h containing information about the source code's Git revision
# (if source directory is a Git clone)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    COMMAND
    ${CMAKE_COMMAND}
    -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
    -DBINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
    -P
    ${CMAKE_SOURCE_DIR}/src/getgit.cmake
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    PROPERTIES
    GENERATED 1
    HEADER_FILE_ONLY 1
    SKIP_AUTOMOC ON
    SKIP_AUTOUIC ON
    SKIP_AUTOGEN ON
)

add_library( kbibtexpart
    MODULE
    ${kbibtexpart_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
)

target_link_libraries( kbibtexpart
    KF5::Parts
    kbibtexconfig
    kbibtexdata
    kbibtexio
    kbibtexgui
    kbibtexproc
)

install(
    TARGETS
    kbibtexpart
    DESTINATION
    ${KDE_INSTALL_PLUGINDIR}
)
kcoreaddons_desktop_to_json(kbibtexpart kbibtexpart.desktop SERVICE_TYPES kpart.desktop)
install(
    FILES
    kbibtexpart.desktop
    DESTINATION
    ${KDE_INSTALL_KSERVICES5DIR}
)
install(
    FILES
    kbibtexpartui.rc
    DESTINATION
    ${KDE_INSTALL_KXMLGUI5DIR}/kbibtexpart
)

=== src/processing/CMakeLists.txt ===
# KBibTeX Processing library

set(
    kbibtexproc_LIB_SRCS
    findduplicates.cpp
    idsuggestions.cpp
    lyx.cpp
    checkbibtex.cpp
    bibliographyservice.cpp
    journalabbreviations.cpp
    logging_processing.cpp
)

set(
    kbibtexproc_HDRS
    findduplicates.h
    idsuggestions.h
    lyx.h
    checkbibtex.h
    bibliographyservice.h
    journalabbreviations.h
)

if(UNITY_BUILD)
    enable_unity_build(kbibtexproc kbibtexproc_LIB_SRCS)
endif(UNITY_BUILD)

include_directories(
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_BINARY_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/src/gui
)

add_library(
    kbibtexproc
    SHARED
    ${kbibtexproc_LIB_SRCS}
)

target_link_libraries( kbibtexproc
    Qt5::Core
    KF5::Parts
    kbibtexconfig
    kbibtexdata
    kbibtexio
)

set_target_properties(
    kbibtexproc
    PROPERTIES
    EXPORT_NAME "kbibtexproc"
    VERSION ${KBIBTEX_RELEASE_VERSION}
    SOVERSION ${KBIBTEX_SOVERSION}
)

install(
    TARGETS
    kbibtexproc
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

generate_export_header( kbibtexproc )

=== src/program/CMakeLists.txt ===
# KBibTeX main program

project(
    kbibtexprogram
)

set(
    kbibtex_SRCS
    program.cpp
    mainwindow.cpp
    documentlist.cpp
    mdiwidget.cpp
    docklets/statistics.cpp
    docklets/referencepreview.cpp
    docklets/documentpreview.cpp
    docklets/valuelist.cpp
    docklets/searchform.cpp
    docklets/searchresults.cpp
    docklets/elementform.cpp
    docklets/filesettings.cpp
    openfileinfo.cpp
    ${CMAKE_SOURCE_DIR}/src/global/kbibtex.cpp
    logging_program.cpp
)

if(BUILD_ZOTERO)
    list(
        APPEND
        kbibtex_SRCS
        docklets/zoterobrowser.cpp
        )
endif(BUILD_ZOTERO)


if(UNITY_BUILD AND NOT WIN32) # FIXME: Unity build of programs breaks on Windows
    enable_unity_build(kbibtex kbibtex_SRCS)
endif(UNITY_BUILD AND NOT WIN32)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_BINARY_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_BINARY_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/processing
    ${CMAKE_BINARY_DIR}/src/processing
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_BINARY_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/io/config
    ${CMAKE_SOURCE_DIR}/src/networking
    ${CMAKE_BINARY_DIR}/src/networking
    ${CMAKE_SOURCE_DIR}/src/networking/onlinesearch
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_BINARY_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/src/gui/widgets
    ${CMAKE_SOURCE_DIR}/src/gui/file
    ${CMAKE_SOURCE_DIR}/src/gui/element
    ${CMAKE_SOURCE_DIR}/src/program/docklets
    ${CMAKE_SOURCE_DIR}/src/global
)

ecm_add_app_icon( kbibtex_SRCS
    ICONS
    ${CMAKE_SOURCE_DIR}/icons/128-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/16-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/22-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/32-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/48-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/64-apps-kbibtex.png
)

# Creates kbibtex-git-info.h containing information about the source code's Git revision
# (if source directory is a Git clone)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    COMMAND
    ${CMAKE_COMMAND}
    -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
    -DBINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
    -P
    ${CMAKE_SOURCE_DIR}/src/getgit.cmake
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    PROPERTIES
    GENERATED 1
    HEADER_FILE_ONLY 1
    SKIP_AUTOMOC ON
    SKIP_AUTOUIC ON
    SKIP_AUTOGEN ON
)

add_executable(
    kbibtex
    ${kbibtex_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
)

target_link_libraries( kbibtex
    Qt5::Core
    Qt5::Widgets
    KF5::CoreAddons
    KF5::I18n
    KF5::ConfigCore
    KF5::Service
    KF5::Parts
    KF5::IconThemes
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::KIONTLM
    KF5::Crash
    kbibtexio
    kbibtexgui
    kbibtexnetworking
)

if(Qt5WebEngineWidgets_FOUND)
    target_link_libraries( kbibtex
        Qt5::WebEngineWidgets
    )
else(Qt5WebEngineWidgets_FOUND)
    if(Qt5WebKitWidgets_FOUND)
        target_link_libraries( kbibtex
            Qt5::WebKitWidgets
        )
    endif(Qt5WebKitWidgets_FOUND)
endif(Qt5WebEngineWidgets_FOUND)

install(
    TARGETS
    kbibtex
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

install(
    PROGRAMS
    org.kde.kbibtex.desktop
    DESTINATION
    ${KDE_INSTALL_APPDIR}
)
install(
    FILES
    kbibtexui.rc
    DESTINATION
    ${KDE_INSTALL_KXMLGUI5DIR}/kbibtex
)
install(
    FILES
    org.kde.kbibtex.appdata.xml
    DESTINATION
    ${KDE_INSTALL_METAINFODIR}
)

ecm_install_icons(
    ICONS
    ${CMAKE_SOURCE_DIR}/icons/128-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/16-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/22-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/32-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/48-apps-kbibtex.png
    ${CMAKE_SOURCE_DIR}/icons/64-apps-kbibtex.png
    DESTINATION ${KDE_INSTALL_ICONDIR}
)

=== src/test/CMakeLists.txt ===
# KBibTeX test program

project(
    test
)

include(
    AddFileDependencies
)
include(
    ECMMarkAsTest
)

configure_file(test-config.h.in test-config.h @ONLY)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src/config
    ${CMAKE_SOURCE_DIR}/src/data
    ${CMAKE_SOURCE_DIR}/src/io
    ${CMAKE_SOURCE_DIR}/src/global
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/src/gui/config
    ${CMAKE_SOURCE_DIR}/src/gui/bibtex
    ${CMAKE_SOURCE_DIR}/src/gui/element
    ${CMAKE_SOURCE_DIR}/src/gui/widgets
    ${CMAKE_SOURCE_DIR}/src/networking
    ${CMAKE_SOURCE_DIR}/src/networking/onlinesearch
    ${CMAKE_SOURCE_DIR}/src/processing
)

set(
    kbibtextest_SRCS
    main.cpp
    kbibtextest.cpp
    logging_test.cpp
)

set(
    kbibtexfilestest_SRCS
    kbibtexfilestest.cpp
    kbibtexfilestest-rawdata.h
)

if(UNITY_BUILD AND NOT WIN32) # FIXME: Unity build of programs breaks on Windows
    enable_unity_build(kbibtextest kbibtextest_SRCS)
    enable_unity_build(kbibtexfilestest kbibtexfilestest_SRCS)
endif(UNITY_BUILD AND NOT WIN32)

# Creates kbibtex-git-info.h containing information about the source code's Git revision
# (if source directory is a Git clone)
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    COMMAND
    ${CMAKE_COMMAND}
    -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
    -DBINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}
    -P
    ${CMAKE_SOURCE_DIR}/src/getgit.cmake
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
    PROPERTIES
    GENERATED 1
    HEADER_FILE_ONLY 1
    SKIP_AUTOMOC ON
    SKIP_AUTOUIC ON
    SKIP_AUTOGEN ON
)

add_executable(
    kbibtextest
    ${kbibtextest_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
)

add_executable(
    kbibtexfilestest
    ${kbibtexfilestest_SRCS}
    ${CMAKE_CURRENT_BINARY_DIR}/kbibtex-git-info.h
)

target_link_libraries( kbibtextest
    Qt5::Core
    KF5::KIOCore
    kbibtexconfig
    kbibtexdata
    kbibtexio
    kbibtexproc
    kbibtexgui
    kbibtexnetworking
)

target_link_libraries( kbibtexfilestest
    Qt5::Test
    kbibtexdata
    kbibtexio
)

ecm_mark_as_test(
    kbibtexfilestest
)

add_test(
    NAME
    kbibtexfilestest
    COMMAND
    kbibtexfilestest
)

=== debian/changelog ===
kbibtex (0.8.1-1ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:21:25 +0100

kbibtex (0.8.1-1ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 07:59:39 +0100

kbibtex (0.8.1-1ubuntu3) disco; urgency=medium

  * debian/tests/run: Pass --class to xdotool, to exclude the Qt Selection
    window from the search results.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 03 Apr 2019 13:52:18 +0300

kbibtex (0.8.1-1ubuntu2) disco; urgency=medium

  * No-change rebuild for icu soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 13 Nov 2018 08:02:07 +0000

kbibtex (0.8.1-1ubuntu1) disco; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use real KDE Frameworks -dev package build depends, instead of
      dropped transitionals.
      + kio-dev -> libkf5kio-dev
      + kdoctools-dev -> libkf5doctools-dev

 -- Rik Mills <rikmills@kubuntu.org>  Sun, 11 Nov 2018 09:24:08 +0000

kbibtex (0.8.1-1) unstable; urgency=medium

  * New upstream version based on KDE Frameworks
    5", thanks to Pierre Haessig (Closes: #907030).
  * Bug fix: "kbibtex FTBFS: delegate-failed rsvg-convert", thanks to
    Helmut Grohne (Closes: #893538).
  * Bug fix: "[kbibtex] kbibtex icon is not correctly converted", thanks
    to Antonio Russo (Closes: #894653).
  * Bug fix: "project homepage changed gna.org -> kde.org", thanks to
    Pierre Haessig (Closes: #901856).
  * Bug fix: "kbibtex FTBFS: delegate-failed rsvg-convert", thanks to
    Helmut Grohne (Closes: #893538).

 -- Bastien Roucariès <rouca@debian.org>  Fri, 19 Oct 2018 17:16:30 +0200

=== debian/control ===
Source: kbibtex
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Bastien Roucariès <rouca@debian.org>
Section: kde
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake (>= 2.8.12~),
               extra-cmake-modules,
               qtbase5-dev-tools,
               qtbase5-dev,
               libkf5i18n-dev,
               libkf5xmlgui-dev,
               libkf5iconthemes-dev (>= 5.6.0~),
               libkf5itemviews-dev (>= 5.6.0~),
               libkf5completion-dev (>= 5.6.0~),
               libkf5doctools-dev,
               libkf5kio-dev,
               libkf5parts-dev (>= 5.6.0~),
               libkf5coreaddons-dev (>= 5.6.0~),
               libkf5service-dev (>= 5.6.0~),
               libkf5wallet-dev (>= 5.6.0~),
               libkf5crash-dev (>= 5.6.0~),
               libqt5xmlpatterns5-dev (>= 5.6.0~),
               libqca-qt5-2-dev (>= 2.1.0~),
               libpoppler-qt5-dev,
               libxslt1-dev,
               pkg-kde-tools (>= 0.12),
	       imagemagick,
	       inkscape,
	       librsvg2-bin
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/kbibtex
Vcs-Git: https://salsa.debian.org/science-team/kbibtex.git
Homepage: https://userbase.kde.org/KBibTeX

Package: kbibtex
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
	 kbibtex-data (= ${source:Version}),
Recommends: texlive-bibtex-extra, biber
Suggests: texlive-latex-base,
          bibtex2html,
          latex2rtf
Multi-Arch: foreign
Description: BibTeX editor for KDE
 An application to manage bibliography databases in the BibTeX format. KBibTeX
 can be used as a standalone program, but can also be embedded into other KDE
 applications (e.g. as bibliography editor into Kile).
 .
 KBibTeX can query online resources (e.g. Google scholar) via customizable
 search URLs. It is also able to import complete datasets from NCBI Pubmed.
 It also supports tagging references with keywords and manages references to
 local files.
 .
 BibTeX files can be exported into HTML, XML, PDF, PS and RTF format using a
 number of citation styles.

Package: kbibtex-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: texlive-bibtex-extra
Breaks: kbibtex (<< 0.6+git7fdc0cd97c093f-1~)
Replaces: kbibtex (<< 0.6+git7fdc0cd97c093f-1~)
Description: BibTeX editor for KDE -- common data
 An application to manage bibliography databases in the BibTeX format. KBibTeX
 can be used as a standalone program, but can also be embedded into other KDE
 applications (e.g. as bibliography editor into Kile).
 .
 KBibTeX can query online resources (e.g. Google scholar) via customizable
 search URLs. It is also able to import complete datasets from NCBI Pubmed.
 It also supports tagging references with keywords and manages references to
 local files.
 .
 BibTeX files can be exported into HTML, XML, PDF, PS and RTF format using a
 number of citation styles.
 .
 This package include common data needed by kbibtex binaries.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export QT_SELECT:=5

export STATIC_DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_HOST_GNU_TYPE  ?= $(STATIC_DEB_HOST_GNU_TYPE)
export STATIC_DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH ?= $(STATIC_DEB_HOST_MULTIARCH)
export STATIC_DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(STATIC_DEB_BUILD_GNU_TYPE)

DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

# icons
ICONSSIZE ?= 8x8 16x16 22x22 24x24 32x32 36x36 42x42 48x48 64x64 72x72 96x96 128x128 192x192 256x256
CONVERT_FLAGS ?= -background none -define filter:blur=0.75 -filter Gaussian
CONVERT ?= convert

# one ring to rule them all ...
%:
	dh $@

# pass as-needed and security flags
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_C_FLAGS="$(CFLAGS)" -DCMAKE_CXX_FLAGS="$(CFLAGS)" \
		-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
		-DCMAKE_MODULE_LINKER_FLAGS="$(LDFLAGS)" \
		-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install
	# remove .so symlink to private lib
	rm -f $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so
	# rebuild icons
	rm -rf debian/tmp/usr/share/icons
	# build icons cache (build for each arch in order to get more testing)
	set -e; for SIZE in $(ICONSSIZE); do \
		mkdir -p debian/tmp/usr/share/icons/hicolor/$$SIZE/apps/ ;\
		echo "Make icons for size $$SIZE..."; \
		$(CONVERT) icons/kbibtex.svg \
			   $(CONVERT_FLAGS) -resize $$SIZE \
			   -gravity center -extent $$SIZE  \
			   +set date:create +set date:modify -define png:exclude-chunk=time  \
			   debian/tmp/usr/share/icons/hicolor/$$SIZE/apps/kbibtex.png; \
		echo "Done"; \
	done
	# do not forget svgz
	mkdir -p debian/tmp/usr/share/icons/hicolor/scalable/apps/
	gzip -c -n -9 icons/kbibtex.svg \
		> debian/tmp/usr/share/icons/hicolor/scalable/apps/kbibtex.svgz

# not yet due to fail
override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
https://github.com/KDE/kbibtex/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
